Unit ASS1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAS10_p;

procedure ASS1R(var B :Array of Real; N :Integer; SUBA :Proc_FA;
                SUBAT :Proc_FA; var X :Array of Real; var RSQ :Real;
                ITMAX :Integer; EPS :Real; var G :Array of Real;
                var H :Array of Real; var XI :Array of Real;
                var XJ :Array of Real; var IERR :Integer);

implementation

procedure ASS1R(var B :Array of Real; N :Integer; SUBA :Proc_FA;
                SUBAT :Proc_FA; var X :Array of Real; var RSQ :Real;
                ITMAX :Integer; EPS :Real; var G :Array of Real;
                var H :Array of Real; var XI :Array of Real;
                var XJ :Array of Real; var IERR :Integer);
var
IRST,J,I :Integer;
EPS2,RP,BSQ,ANUM,ADEN,GG,DGG,GAM :Real;
const
ZERO :Real = 0.0;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130;
begin

{            }
{       AX=B      - }
{         }


{        B -    N,   }
{               ; }

{        N -    (: ); }

{     SUBA -    A*X,   }
{              : SUBROUTINE SUBA(X,AX),  X - - }
{               N,    }
{             X, ATX -    N, - }
{               A*X; }

{    SUBAT -    A'*X,   }
{              : SUBROUTINE SUBAT(X,ATX),  X - - }
{               N,    }
{             X, ATX -    N, - }
{               A'*X; }

{        X -    N,     - }
{                 ,   }
{             -   ; }

{      RSQ -  ,    - }
{                A*X-B; }

{    ITMAX -      - }
{               (: ); }

{      EPS -  ,      }
{             (: ); }

{    G, H, -    N,    }
{   XI, XJ     ; }

{     IERR -  ,     , - }
{                ;   }

{            IERR = 65 -    : }
{            IERR = 66 -       - }
{                             }


{        ASS1RR     ITER, - }
{             }
{       }

IERR := 0;

{             - }
{       A*X-B }

EPS2 := N*EPS*EPS;
IRST := 0;
_10:
IRST := IRST+1;

{         }

SUBA(X,XI);
RP := ZERO;
BSQ := ZERO;

{       ,     }
{       }

for J:=1 to N do
 begin
  BSQ := BSQ+IntPower(B[J-1],2);
  XI[J-1] := XI[J-1]-B[J-1];
  RP := RP+IntPower(XI[J-1],2);
_20:
 end;
SUBAT(XI,G);
for J:=1 to N do
 begin
  G[J-1] := -G[J-1];
  H[J-1] := G[J-1];
_30:
 end;

{            }

for I:=1 to ITMAX do
 begin
  _ASS1RR.elm1 := I;
  SUBA(H,XI);
  ANUM := ZERO;
  ADEN := ZERO;
  for J:=1 to N do
   begin
    ANUM := ANUM+G[J-1]*H[J-1];
    ADEN := ADEN+IntPower(XI[J-1],2);
_40:
   end;
  if ( ADEN <> 0 )
   then goto _50;

{          }

  IERR := 65;
  UTAS10(IERR,6);
  goto _130;
_50:
  ANUM := ANUM/ADEN;
  for J:=1 to N do
   begin
    XI[J-1] := X[J-1];
    X[J-1] := X[J-1]+ANUM*H[J-1];
_60:
   end;
  SUBA(X,XJ);
  RSQ := ZERO;
  for J:=1 to N do
   begin
    XJ[J-1] := XJ[J-1]-B[J-1];
    RSQ := RSQ+IntPower(XJ[J-1],2);
_70:
   end;

{        ,      }
{       }

  if ( RSQ = RP ) or ( RSQ <= BSQ*EPS2 ) 
   then goto _130;
  if ( RSQ <= RP ) 
   then goto _90;
  for J:=1 to N do
   begin
    X[J-1] := XI[J-1];
_80:
   end;
  if ( IRST >= 3 ) 
   then goto _130;
  goto _10;
_90:
  RP := RSQ;

{           }

  SUBAT(XJ,XI);
  GG := ZERO;
  DGG := ZERO;
  for J:=1 to N do
   begin
    GG := GG+IntPower(G[J-1],2);
    DGG := DGG+(XI[J-1]+G[J-1])*XI[J-1];
_100:
   end;
  if ( GG = ZERO ) 
   then goto _130;
  GAM := DGG/GG;
  for J:=1 to N do
   begin
    G[J-1] := -XI[J-1];
    H[J-1] := G[J-1]+GAM*H[J-1];
_110:
   end;
_120:
 end;

{              }
{         }

IERR := 66;
UTAS10(IERR,6);
_130:
end;

end.
